const OracleService = require('../service/OracleService');
const axios = require('axios');

class MonitoringController {
  execCommand(command, params) {
    command = `/* === EXECUTED BY ODHEN ASSISTANT === */ \n ${command}`;
    return OracleService.execute(command, params).then((data) => {
      return {
        rows: data.rows,
        metaData: data.metaData
      };
    });
  }

  async execHttpRequest(urls) {
    const result = [];
    return Promise.all(urls.map((url) => {
      return new Promise((resolve) => {
        axios.get(url.trim(), {}, { timeout: 10000 }).then(() => {
          result.push({
            URL   : url.trim(),
            ERROR : '',
            STATUS: 'S'
          });
          resolve();
        }).catch((error) => {
          result.push({
            URL   : url.trim(),
            ERROR : error.message,
            STATUS: 'N'
          });
          resolve();
        });
      });
    })).then(() => {
      return result.sort(this.orderResult);
    });
  }

  orderResult(result1, result2) {
    if(result1.STATUS == 'N' && result2.STATUS == 'S') {
      return -1;
    } else if(result1.STATUS == 'S' && result2.STATUS == 'N') {
      return 1;
    } else {
      return 0;
    }
  }
}

module.exports = new MonitoringController();
